Index: cpukit/libdl/include/sys/exec_elf.h
===================================================================
--- cpukit/libdl/include/sys/exec_elf.h	(revision a1c60b5690a028aeafb62d13015fa56187bc3572)
+++ cpukit/libdl/include/sys/exec_elf.h	(revision bba48d90bcd343f62b368a510b67bbdb51fb6f0c)
@@ -460,4 +460,8 @@
 #define	SHF_ALLOC	0x2		/* Section occupies memory */
 #define	SHF_EXECINSTR	0x4		/* Section contains executable insns */
+#define	SHF_MERGE	0x10		/* Section contains data that can be merged */
+#define	SHF_STRINGS	0x20		/* Section contains null-terminated strings */
+#define	SHF_INFO_LINK	0x40		/* Section header's sh_info holds table index */
+#define	SHF_LINK_ORDER	0x80		/* Section has special ordering requirements */
 
 #define	SHF_MASKOS	0x0f000000	/* Operating system specific values */
@@ -950,5 +954,5 @@
 
 /*
- * These constants are used for Elf32_Verdef struct's version number.  
+ * These constants are used for Elf32_Verdef struct's version number.
  */
 #define VER_DEF_NONE		0
@@ -956,5 +960,5 @@
 
 /*
- * These constants are used for Elf32_Verdef struct's vd_flags.  
+ * These constants are used for Elf32_Verdef struct's vd_flags.
  */
 #define VER_FLG_BASE		0x1
@@ -968,5 +972,5 @@
 
 /*
- * These constants are used for Elf32_Verneed struct's version number.  
+ * These constants are used for Elf32_Verneed struct's version number.
  */
 #define	VER_NEED_NONE		0
Index: cpukit/libdl/rtl-elf.c
===================================================================
--- cpukit/libdl/rtl-elf.c	(revision a1c60b5690a028aeafb62d13015fa56187bc3572)
+++ cpukit/libdl/rtl-elf.c	(revision bba48d90bcd343f62b368a510b67bbdb51fb6f0c)
@@ -657,4 +657,9 @@
     flags = 0;
 
+    if (rtems_rtl_trace (RTEMS_RTL_TRACE_DETAIL))
+      printf ("rtl: section: %2d: type=%d flags=%08x link=%d info=%d\n",
+              section, (int) shdr.sh_type, (unsigned int) shdr.sh_flags,
+              (int) shdr.sh_link, (int) shdr.sh_info);
+
     switch (shdr.sh_type)
     {
@@ -713,5 +718,5 @@
       default:
         /*
-         * See there are architecture specific flags?
+         * See if there are architecture specific flags?
          */
         flags = rtems_rtl_elf_section_flags (obj, &shdr);
@@ -729,4 +734,11 @@
       char*  name;
       size_t len;
+
+      /*
+       * If link ordering this section must appear in the same order in memory
+       * as the linked-to section relative to the sections it loads with.
+       */
+      if ((shdr.sh_flags & SHF_LINK_ORDER) != 0)
+        flags |= RTEMS_RTL_OBJ_SECT_LINK;
 
       len = RTEMS_RTL_ELF_STRING_MAX;
Index: cpukit/libdl/rtl-mdreloc-sparc.c
===================================================================
--- cpukit/libdl/rtl-mdreloc-sparc.c	(revision a1c60b5690a028aeafb62d13015fa56187bc3572)
+++ cpukit/libdl/rtl-mdreloc-sparc.c	(revision bba48d90bcd343f62b368a510b67bbdb51fb6f0c)
@@ -254,5 +254,6 @@
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_RELOC))
     printf ("rtl: %s %p @ %p in %s\n",
-            reloc_names[type], (void *)tmp, where, rtems_rtl_obj_oname (obj));
+            reloc_names[ELF_R_TYPE(rela->r_info)],
+            (void *)tmp, where, rtems_rtl_obj_oname (obj));
 
   return true;
Index: cpukit/libdl/rtl-obj.c
===================================================================
--- cpukit/libdl/rtl-obj.c	(revision a1c60b5690a028aeafb62d13015fa56187bc3572)
+++ cpukit/libdl/rtl-obj.c	(revision bba48d90bcd343f62b368a510b67bbdb51fb6f0c)
@@ -602,10 +602,10 @@
 rtems_rtl_obj_sect_sync_handler (rtems_chain_node* node, void* data)
 {
-  rtems_rtl_obj_sect_t*   sect = (rtems_rtl_obj_sect_t*) node;
+  rtems_rtl_obj_sect_t*          sect = (rtems_rtl_obj_sect_t*) node;
   rtems_rtl_obj_sect_sync_ctx_t* sync_ctx = data;
-  uintptr_t old_end;
-  uintptr_t new_start;
-
-  if ( !(sect->flags & sync_ctx->mask) || !sect->size)
+  uintptr_t                      old_end;
+  uintptr_t                      new_start;
+
+  if ((sect->flags & sync_ctx->mask) == 0 || sect->size == 0)
     return true;
 
@@ -633,5 +633,5 @@
 
 void
-rtems_rtl_obj_synchronize_cache (rtems_rtl_obj_t*    obj)
+rtems_rtl_obj_synchronize_cache (rtems_rtl_obj_t* obj)
 {
   rtems_rtl_obj_sect_sync_ctx_t sync_ctx;
@@ -644,5 +644,5 @@
   sync_ctx.mask = RTEMS_RTL_OBJ_SECT_TEXT | RTEMS_RTL_OBJ_SECT_CONST |
                   RTEMS_RTL_OBJ_SECT_DATA | RTEMS_RTL_OBJ_SECT_BSS |
-                  RTEMS_RTL_OBJ_SECT_EXEC;
+                  RTEMS_RTL_OBJ_SECT_EH   | RTEMS_RTL_OBJ_SECT_EXEC;
 
   sync_ctx.start_va = 0;
@@ -666,4 +666,85 @@
   uint32_t mask = RTEMS_RTL_OBJ_SECT_SYM;
   return rtems_rtl_obj_section_handler (mask, obj, fd, handler, data);
+}
+
+static int
+rtems_rtl_obj_sections_linked_to_order (rtems_rtl_obj_t* obj,
+                                        int              section,
+                                        uint32_t         visited_mask)
+{
+  rtems_chain_control* sections = &obj->sections;
+  rtems_chain_node*    node = rtems_chain_first (sections);
+  /*
+   * Find the section being linked-to. If the linked-to link field is 0 we have
+   * the end and the section's order is the position we are after.
+   */
+  while (!rtems_chain_is_tail (sections, node))
+  {
+    rtems_rtl_obj_sect_t* sect = (rtems_rtl_obj_sect_t*) node;
+    if (sect->section == section)
+    {
+      const uint32_t mask = sect->flags & RTEMS_RTL_OBJ_SECT_TYPES;
+      int            order = 0;
+      if (sect->link != 0)
+      {
+        /*
+         * Have we already visited this type of section? Avoid nesting for
+         * ever.
+         */
+        if ((sect->flags & visited_mask) != 0)
+        {
+          rtems_rtl_set_error (errno, "section link loop");
+          return -1;
+        }
+        return rtems_rtl_obj_sections_linked_to_order (obj,
+                                                       sect->link,
+                                                       visited_mask | mask);
+      }
+      node = rtems_chain_first (sections);
+      while (!rtems_chain_is_tail (sections, node))
+      {
+        sect = (rtems_rtl_obj_sect_t*) node;
+        if ((sect->flags & mask) == mask)
+        {
+          if (sect->section == section)
+            return order;
+          ++order;
+        }
+        node = rtems_chain_next (node);
+      }
+    }
+    node = rtems_chain_next (node);
+  }
+  rtems_rtl_set_error (errno, "section link not found");
+  return -1;
+}
+
+static void
+rtems_rtl_obj_sections_link_order (uint32_t mask, rtems_rtl_obj_t* obj)
+{
+  rtems_chain_control* sections = &obj->sections;
+  rtems_chain_node*    node = rtems_chain_first (sections);
+  int                  order = 0;
+  while (!rtems_chain_is_tail (sections, node))
+  {
+    rtems_rtl_obj_sect_t* sect = (rtems_rtl_obj_sect_t*) node;
+    if ((sect->flags & mask) == mask)
+    {
+      /*
+       * If the section is linked in order find the linked-to section's order
+       * and move the section in the section list to
+       */
+      if (sect->link == 0)
+        sect->load_order = order++;
+      else
+      {
+        sect->load_order =
+          rtems_rtl_obj_sections_linked_to_order (obj,
+                                                  sect->link,
+                                                  mask);
+      }
+    }
+    node = rtems_chain_next (node);
+  }
 }
 
@@ -680,4 +761,6 @@
   size_t               base_offset = 0;
   bool                 first = true;
+  int                  order = 0;
+
   while (!rtems_chain_is_tail (sections, node))
   {
@@ -686,34 +769,44 @@
     if ((sect->size != 0) && ((sect->flags & mask) != 0))
     {
-      if (!first)
-        base_offset = rtems_rtl_sect_align (base_offset, sect->alignment);
-
-      sect->base = base + base_offset;
-
-      if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
-        printf ("rtl: loading: %s -> %8p (l:%zi m:%04lx)\n",
-                sect->name, sect->base, sect->size, sect->flags);
-
-      if ((sect->flags & RTEMS_RTL_OBJ_SECT_LOAD) == RTEMS_RTL_OBJ_SECT_LOAD)
+      if (sect->load_order == order)
       {
-        if (!handler (obj, fd, sect, data))
+        if (!first)
+          base_offset = rtems_rtl_sect_align (base_offset, sect->alignment);
+
+        first = false;
+
+        sect->base = base + base_offset;
+
+        if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
+          printf ("rtl: loading:%2d: %s -> %8p (s:%zi f:%04lx a:%lu l:%02d)\n",
+                  order, sect->name, sect->base, sect->size,
+                  sect->flags, sect->alignment, sect->link);
+
+        if ((sect->flags & RTEMS_RTL_OBJ_SECT_LOAD) == RTEMS_RTL_OBJ_SECT_LOAD)
+        {
+          if (!handler (obj, fd, sect, data))
+          {
+            sect->base = 0;
+            return false;
+          }
+        }
+        else if ((sect->flags & RTEMS_RTL_OBJ_SECT_ZERO) == RTEMS_RTL_OBJ_SECT_ZERO)
+        {
+          memset (base + base_offset, 0, sect->size);
+        }
+        else
         {
           sect->base = 0;
+          rtems_rtl_set_error (errno, "section has no load/clear op");
           return false;
         }
+
+        base_offset += sect->size;
+
+        ++order;
+
+        node = rtems_chain_first (sections);
+        continue;
       }
-      else if ((sect->flags & RTEMS_RTL_OBJ_SECT_ZERO) == RTEMS_RTL_OBJ_SECT_ZERO)
-      {
-        memset (base + base_offset, 0, sect->size);
-      }
-      else
-      {
-        sect->base = 0;
-        rtems_rtl_set_error (errno, "section has no load op");
-        return false;
-      }
-
-      base_offset += sect->size;
-      first = false;
     }
 
@@ -764,5 +857,5 @@
   }
 
-  obj->exec_size = text_size + const_size + data_size + bss_size;
+  obj->exec_size = text_size + const_size + eh_size + data_size + bss_size;
 
   if (rtems_rtl_trace (RTEMS_RTL_TRACE_LOAD_SECT))
@@ -779,4 +872,12 @@
             obj->bss_base, bss_size, rtems_rtl_obj_bss_alignment (obj));
   }
+
+  /*
+   * Determine the load order.
+   */
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_TEXT,  obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_CONST, obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_EH,    obj);
+  rtems_rtl_obj_sections_link_order (RTEMS_RTL_OBJ_SECT_DATA,  obj);
 
   /*
Index: cpukit/libdl/rtl-obj.h
===================================================================
--- cpukit/libdl/rtl-obj.h	(revision a1c60b5690a028aeafb62d13015fa56187bc3572)
+++ cpukit/libdl/rtl-obj.h	(revision bba48d90bcd343f62b368a510b67bbdb51fb6f0c)
@@ -103,6 +103,17 @@
 #define RTEMS_RTL_OBJ_SECT_EXEC  (1 << 12) /**< Section is executable. */
 #define RTEMS_RTL_OBJ_SECT_ZERO  (1 << 13) /**< Section is preset to zero. */
-#define RTEMS_RTL_OBJ_SECT_CTOR  (1 << 14) /**< Section contains constructors. */
-#define RTEMS_RTL_OBJ_SECT_DTOR  (1 << 15) /**< Section contains destructors. */
+#define RTEMS_RTL_OBJ_SECT_LINK  (1 << 14) /**< Section is link-ordered. */
+#define RTEMS_RTL_OBJ_SECT_CTOR  (1 << 15) /**< Section contains constructors. */
+#define RTEMS_RTL_OBJ_SECT_DTOR  (1 << 16) /**< Section contains destructors. */
+#define RTEMS_RTL_OBJ_SECT_LOCD  (1 << 17) /**< Section has been located. */
+
+/**
+ * Section types mask.
+ */
+#define RTEMS_RTL_OBJ_SECT_TYPES (RTEMS_RTL_OBJ_SECT_TEXT | \
+                                  RTEMS_RTL_OBJ_SECT_CONST | \
+                                  RTEMS_RTL_OBJ_SECT_DATA | \
+                                  RTEMS_RTL_OBJ_SECT_BSS | \
+                                  RTEMS_RTL_OBJ_SECT_EH)
 
 /**
@@ -125,4 +136,5 @@
   void*            base;        /**< The base address of the section in
                                  *   memory. */
+  int              load_order;  /**< Order we load sections. */
 };
 
